> ## Documentation Index
> Fetch the complete documentation index at: https://docs.roark.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a metric policy

> Creates a new metric policy. Policies define which metrics to collect and under what conditions.



## OpenAPI

````yaml /api-reference/openapi.documented.json post /v1/metric/policies
openapi: 3.1.0
info:
  title: Roark Analytics API
  description: >-
    The Roark Analytics API gives you access to the same API that powers the
    award winning Roark Analytics platform.
  version: 1.0.0
servers:
  - description: Production
    url: https://api.roark.ai
security:
  - Bearer: []
tags:
  - name: Agent
  - name: Agent Endpoint
  - name: Call
  - name: Chat
  - name: Metric
  - name: Metric Policy
  - name: Metric Collection Job
  - name: Simulation Persona
  - name: Simulation Scenario
  - name: Simulation Run Plan
  - name: Simulation Run Plan Job
  - name: Simulation Job
  - name: HTTP Request Definition
  - name: Webhook
  - name: Issue
  - name: Knowledge Base
  - name: Call Analysis
  - name: Health
paths:
  /v1/metric/policies:
    post:
      tags:
        - Metric Policy
      summary: Create a metric policy
      description: >-
        Creates a new metric policy. Policies define which metrics to collect
        and under what conditions.
      operationId: postV1MetricPolicies
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateMetricPolicyInput'
      responses:
        '201':
          description: The created metric policy
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/MetricPolicyResponse'
                required:
                  - data
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Validation error
              example:
                type: validation
                code: invalid_parameter
                message: The request was invalid
                param: email
          description: Bad Request
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Authentication error
              example:
                type: authentication
                code: unauthorized
                message: Authentication required
          description: Unauthorized
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Permission error
              example:
                type: forbidden
                code: permission_denied
                message: You do not have permission to access this resource
          description: Forbidden
        '429':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Rate limit error
              example:
                type: rate_limit
                code: too_many_requests
                message: Rate limit exceeded
          description: Too Many Requests
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Server error
              example:
                type: internal
                code: internal_error
                message: Internal server error
          description: Internal Server Error
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Roark from '@roarkanalytics/sdk';

            const client = new Roark({
              bearerToken: process.env['ROARK_API_BEARER_TOKEN'], // This is the default and can be omitted
            });

            const metricPolicy = await client.metricPolicy.create({
              metrics: [{ id: '182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e' }],
              modality: 'call',
              name: 'Evaluate all inbound calls',
            });

            console.log(metricPolicy.data);
        - lang: Python
          source: |-
            import os
            from roark_analytics import Roark

            client = Roark(
                bearer_token=os.environ.get("ROARK_API_BEARER_TOKEN"),  # This is the default and can be omitted
            )
            metric_policy = client.metric_policy.create(
                metrics=[{
                    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
                }],
                modality="call",
                name="Evaluate all inbound calls",
            )
            print(metric_policy.data)
components:
  schemas:
    CreateMetricPolicyInput:
      type: object
      properties:
        name:
          type: string
          minLength: 1
          description: Name of the metric policy
          example: Evaluate all inbound calls
        status:
          type: string
          enum:
            - ACTIVE
            - INACTIVE
          default: ACTIVE
          description: 'Status of the policy (default: ACTIVE)'
          example: ACTIVE
        modality:
          type: string
          enum:
            - call
            - chat
          description: >-
            Modality this policy targets. A policy fires for exactly one
            modality and can only reference metrics that support that modality.
          example: call
        conditions:
          type: array
          items:
            type: object
            properties:
              conditions:
                type: array
                items:
                  type: object
                  properties:
                    conditionType:
                      type: string
                      enum:
                        - AGENT
                        - CALL_SOURCE
                        - CALL_PROPERTY
                        - INTEGRATION
                      description: >-
                        Type of condition: AGENT (match by agent ID),
                        CALL_SOURCE (match by source e.g. VAPI, RETELL),
                        CALL_PROPERTY (match by call property key/value)
                    conditionKey:
                      type: string
                      description: >-
                        Key to match against. For AGENT: the agent ID. For
                        CALL_SOURCE: the source name. For CALL_PROPERTY: the
                        property key.
                    conditionOperator:
                      type:
                        - string
                        - 'null'
                      enum:
                        - EQUALS
                        - NOT_EQUALS
                        - CONTAINS
                        - STARTS_WITH
                        - GREATER_THAN
                        - LESS_THAN
                        - GREATER_THAN_OR_EQUALS
                        - LESS_THAN_OR_EQUALS
                      description: >-
                        Comparison operator. Required for CALL_PROPERTY
                        conditions.
                    conditionValue:
                      type:
                        - string
                        - 'null'
                      description: >-
                        Value to compare against. Required for CALL_PROPERTY
                        conditions.
                  required:
                    - conditionType
                    - conditionKey
            required:
              - conditions
          description: Condition groups. Omit to match all calls.
        metrics:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                format: uuid
            required:
              - id
          minItems: 1
          description: Metric definitions to collect when this policy matches
      required:
        - name
        - modality
        - metrics
      description: Input for creating a new metric policy
    MetricPolicyResponse:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier of the metric policy
        name:
          type: string
          description: Name of the metric policy
        type:
          type: string
          enum:
            - SYSTEM
            - USER
          description: Type of the metric policy (SYSTEM or USER)
        status:
          type: string
          enum:
            - ACTIVE
            - INACTIVE
          description: Status of the metric policy (ACTIVE or INACTIVE)
        conditions:
          type:
            - array
            - 'null'
          items:
            type: object
            properties:
              conditions:
                type: array
                items:
                  type: object
                  properties:
                    conditionType:
                      type: string
                      enum:
                        - AGENT
                        - CALL_SOURCE
                        - CALL_PROPERTY
                        - INTEGRATION
                      description: >-
                        Type of condition: AGENT (match by agent ID),
                        CALL_SOURCE (match by source e.g. VAPI, RETELL),
                        CALL_PROPERTY (match by call property key/value)
                    conditionKey:
                      type: string
                      description: >-
                        Key to match against. For AGENT: the agent ID. For
                        CALL_SOURCE: the source name. For CALL_PROPERTY: the
                        property key.
                    conditionOperator:
                      type:
                        - string
                        - 'null'
                      enum:
                        - EQUALS
                        - NOT_EQUALS
                        - CONTAINS
                        - STARTS_WITH
                        - GREATER_THAN
                        - LESS_THAN
                        - GREATER_THAN_OR_EQUALS
                        - LESS_THAN_OR_EQUALS
                      description: >-
                        Comparison operator. Required for CALL_PROPERTY
                        conditions.
                    conditionValue:
                      type:
                        - string
                        - 'null'
                      description: >-
                        Value to compare against. Required for CALL_PROPERTY
                        conditions.
                  required:
                    - conditionType
                    - conditionKey
                    - conditionOperator
                    - conditionValue
            required:
              - conditions
          description: >-
            Condition groups for this policy. Null means the policy matches all
            calls.
        metrics:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                format: uuid
            required:
              - id
          description: Metric definitions associated with this policy
        createdAt:
          type: string
          description: When the policy was created
        updatedAt:
          type: string
          description: When the policy was last updated
      required:
        - id
        - name
        - type
        - status
        - conditions
        - metrics
        - createdAt
        - updatedAt
      description: A metric policy defining when metrics should be collected
    ErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - validation
            - authentication
            - forbidden
            - not_found
            - conflict
            - rate_limit
            - internal
          description: The error type category
          examples:
            - validation
            - authentication
        code:
          type: string
          description: Machine-readable error code identifier
          examples:
            - invalid_parameter
            - missing_required_field
            - unauthorized
        message:
          type: string
          description: Human-readable error message
          examples:
            - The request was invalid
            - Authentication required
        param:
          type: string
          description: The parameter that caused the error (if applicable)
          examples:
            - email
            - user_id
        details:
          description: Additional error context information
      required:
        - type
        - code
        - message
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer
      bearerFormat: JWT

````